#include <18F4620.h>
#fuses INTRC_IO,NOWDT,NOPROTECT,NOLVP
#use delay(clock=32M)
#use rs232(baud=115200, xmit=PIN_C6, rcv=PIN_C7) 
#define GLCD_WIDTH   128
#define FAST_GLCD

#define asagi  0
#define saga   1
#define sola   2
#define yukari 3

#define soltus 253
#define sagtus 239
#define alttus 247
#define usttus 254
#define orttus 251

#define sayacdeger 8

#define SPEECH_PIN PIN_C2

#define GLCD_CS1     PIN_A0   // Chip Selection 1
#define GLCD_CS2     PIN_A1   // Chip Selection 2
#define GLCD_DI      PIN_A2   // Data or Instruction input
#define GLCD_RW      PIN_A4   // Read/Write
#define GLCD_E       PIN_A5   // Enable

#include <HDM64GS12.c>
#include <graphics.c>
//#include <math.h>

#define RAND_MAX  18 
#INCLUDE <STDLIB.H> 

/*   
#include "splashscreen.h"


#include "hey_converted_1_1.c"
#include "hamm_converted_1_1.c"
#include "ayy_converted_1_1.c"
*/
//int *ptr1, *ptr2 ;
//int gidisyonu;  

//char  score[] = "0000";

char maze[13][26]="xxxxxxxxxxxxxxxxxxxxxxxxx",
                  "                        x",
                  "                        x",
                  "                        x",
                  "                        x",                  
                  "                        x",
                  "                        x",
                  "                        x",
                  "                        x",
                  "                        x",
                  "                        x",
                  "                        x",
                  "xxxxxxxxxxxxxxxxxxxxxxxxx";
                     //    ____             
                     //     O1  I1  I2  S1  S2  Z1  Z2  L1  L2  L3  L4  J1  J2  J3  J4  T1  T2  T3  T4
const char tiles[4][77] = "          x       x        x      x    x xx       xx x    x       x   x   x ",
                          " xx xxxx  x   xx  xx xx   xx xxx  x  xxx  x  xxx  x  xxx  x  xxx  xx xxx xx ",
                          " xx       x  xx    x  xx  x  x    xx      x    x  x      xx   x   x       x ",
                          "          x                                                                 ";
               

typedef struct 
{ 
   int r, c; 
   int pixr, pixc; 
   int type: 5;
   //int dir:  4;

} tileveri;
    
tileveri tile1;
int oncekitus;
int sonrakitile;
int score;
   
  
void beep(int16 period){

   while((period--) != 0)
   {
      output_high(speech_PIN);
      delay_ms(1);
      output_low(speech_PIN);
      delay_ms(1);
   }
} 

void click(int gidisyonu){
      output_high(speech_PIN);
      delay_us(gidisyonu*5);
      output_low(speech_PIN);
      delay_us(gidisyonu*5);
}
  
  
void ciuv(int period, int saysur){
int sayper;
int sayac;
sayper = period;
 while((sayper--) != 0)
 {
      for(sayac=1;sayac<saysur;sayac++)
      {
      output_high(speech_PIN);
      delay_us(sayac);
      delay_us(sayac);
      output_low(speech_PIN);
      delay_us(sayac);
      delay_us(sayac);
      }
 }
}  

void satirbak(){

int  row, col, row2, col2;
int satirdolu;

   for ( col = 1 ; col < 24 ; col++ ){
      satirdolu = 1;
      for ( row = 1; row < 12 ; row++){
          if ( maze[row][col] == ' ' ) satirdolu = 0;   
      }
      if(satirdolu == 1 ) {
         for ( col2 = col ; col2 >= 1 ; col2--){
            for ( row2 = 1 ; row2 < 12 ; row2++){
               maze[row2][col2] = maze [row2][col2-1];
            }
         }
      score++;
      }

   }
}

tusbak(){
int basilantus;
/*output_e (0b101);
printf("\f(%u) ", input_b()); 
output_e (0b110);
printf("(%u) ", input_b());*/
output_e (0b011);
//printf("(%u)", input_b());
basilantus = input_b() | 0b11100000;
//if ( basilantus != 0xFF)   click(0);
if ( oncekitus != basilantus )   { 
  oncekitus = basilantus ;
  //sprintf ( watch , "%u", basilantus);
  return basilantus;
}
else return 0xFF;

}

void sonrtileciz(){

int row, col;

   for ( row = 0 ; row < 4 ; row++){
      for ( col = 0 ; col < 4 ; col++){
      
         if ( tiles[row][sonrakitile*4+col] == 'x' ) 
         glcd_pixel(col+2 , row+29 , 1);
      }
   }
}

void tileciz(){

int row, col;

   for ( row = 0 ; row < 4 ; row++){
      for ( col = 0 ; col < 4 ; col++){
      
         if ( tiles[row][tile1.type*4+col] == 'x' ) 
         glcd_rect(tile1.pixc+col*5, tile1.pixr+row*5,tile1.pixc + col*5+4,tile1.pixr + row*5+4, 0 , 1);
      }
   }
}

void mazebas(){
int row, col;

   for ( row = 1 ; row < 12 ; row++){
      for ( col = 0 ; col < 24 ; col++){
      
         if ( maze[row][col] == 'x' ) glcd_rect(col*5, row*5, col*5+4, row*5+4, 1 , 1);   
      }
   }
}

void mazebasx(){
int row, col;
   printf("\f");
   for ( row = 0 ; row < 13 ; row++){
   printf("\r");   
      for ( col = 0 ; col < 25 ; col++){
      
         if ( maze[row][col] == 'x' ) printf("X");
         else printf(" ");
      }
   }
}

carpmaalt(){

int row, col;

   for ( row = 0 ; row < 4 ; row++){
      for ( col = 3 ; col != 255 ; col--){
      
         if ( tiles[row][tile1.type*4+col] == 'x' && maze [tile1.r+row][tile1.c+col] == 'x' ) return 1;
      }
   }
   return 0;
}

carpmasag(){

int row, col;
   for ( col = 0 ; col < 4 ; col++)
   {
      for ( row = 0 ; row < 4 ; row++)
      {
         if ( tiles[row][tile1.type*4+col] == 'x' && maze [tile1.r+row-1][tile1.c+col] == 'x' ) {
            return 1;
         }
      }
   }
   return 0;
}

carpmasol(){

int row, col;
   for ( col = 0 ; col < 4 ; col++)
   {
      for ( row = 4 ; row != 255 ; row--)
      {
         if ( tiles[row][tile1.type*4+col] == 'x' && maze [tile1.r+row+1][tile1.c+col] == 'x' ) {
            return 1;
         }
      }
   }
   return 0;
}



void main() {


   int tusdeger;
   int row, col;
   int sayac;

/*
   int16 yavaslat1, yavaslat2, randrand;
   int32 splashbekle;
   int  sayac, randx=200, randy=200, dotx, doty ;
   int1  soltusbirak = 1, sagtusbirak = 1;
   int1  soltusbirak2 = 1, sagtusbirak2 = 1;
   int1  twoplayer;
*/
   setup_adc_ports(NO_ANALOGS);
   


   
   
   printf(" Ozkal's PICTRIS (%s) (%s )\n\r",__FILENAME__,__DATE__); 
   
   //srand(29);
   
   port_b_pullups( TRUE );
   
   /*ile (TRUE){
   if ( tusbak() == soltus ) beep(5);
   if ( tusbak() == orttus ) beep(20);
   if ( tusbak() == sagtus ) beep(50);
   }*/
   glcd_init (ON);
   
//   ciuv(1,200);

   //gamescreen(0,0);   

   
   sayac = sayacdeger;
   tile1.type=  rand() ;
//   tile1.dir= 1 ;
   tile1.r=4;
   tile1.c=4;
   tile1.pixr = tile1.r*5;
   tile1.pixc = tile1.c*5;
   tusdeger = 0xFF ;
   oncekitus = 0xFF;
   score = 0;
   //glcd_text57(10, 10, &watch, 1, 1) ;
   while(TRUE){
   
   

   /*if ( tile1.pixr > tile1.r*5 ) tile1.pixr--;
   if ( tile1.pixr < tile1.r*5 ) tile1.pixr++;
   if ( tile1.pixc > tile1.c*5 ) tile1.pixc--;
   if ( tile1.pixc < tile1.c*5 ) tile1.pixc++;*/
   sayac = 255;
   while ( sayac != 0 ){  // && tusdeger == 0xFF
      tusdeger = tusbak();   
      if ( tusdeger != 0xFF ) goto tusgeldi;
      sayac--;
      delay_us(2000);
   }
tusgeldi:   
   //delay_ms(200);
   //tusdeger = tusbak();   
   glcd_fillScreen(0);
   mazebas();
   glcd_line(0, 3, 127, 3, 1) ;
   glcd_line(0, 61, 127, 61, 1) ;
   glcd_line(121 , 5, 121, 59, 1) ;
   if ( tile1.c >= 2 ) sonrtileciz();
   if ( tusdeger == orttus ){
      tile1.type++;
      if ( tile1.type == 20 ) tile1.type = 0;
   }
   if ( tusdeger == soltus ){
    switch (tile1.type) {

      case 0:
         break;
      case 1:
            tile1.type = 2;
         break;
      case 2:
            tile1.type = 1;
         break; 
      case 3:
            tile1.type = 4;         
         break;            
      case 4:
            tile1.type = 3;         
         break;
      case 5:
            tile1.type = 6;
         break;       
      case 6:
            tile1.type = 5;
         break;       
      case 7:
            tile1.type = 8;
         break;       
      case 8:
            tile1.type = 9;
         break;                
      case 9:
            tile1.type = 10;
         break;
      case 10:
            tile1.type = 7;
         break;                    
      case 11:
            tile1.type = 12;
         break;
      case 12:
            tile1.type = 13;
         break;         
      case 13:
            tile1.type = 14;
         break;
      case 14:
            tile1.type = 11;
         break;         
      case 15:
            tile1.type = 16;
         break;          
      case 16:
            tile1.type = 17;
         break;                   
      case 17:
            tile1.type = 18;
         break;                   
      case 18:
            tile1.type = 15;
         break;                   
    }
     if ( carpmasag () == 1 && tile1.type!=0 && tile1.type!=10 && tile1.type!=7 && tile1.type!=9 && tile1.type!=13 && tile1.type!=14 && tile1.type!=17 && tile1.type!=18) tile1.r = tile1.r + 1; //tile1.r == 0 &&
     if ( carpmasol () == 1 && tile1.type!=0 && tile1.type!=1 && tile1.type!=4&& tile1.type!=3 && tile1.type!=5 && tile1.type!=6 && tile1.type!=7 && tile1.type!=8 && tile1.type!=12 && tile1.type!=11 && tile1.type!=16 ) tile1.r = tile1.r - 1; //tile1.r >= 9 && 
     if ( carpmasol () == 1 && tile1.type==2) tile1.r = tile1.r - 2;
   }
   //if ( tusdeger == soltus && tile1.r != 9 )tile1.r =tile1.r + 1 ;   
   //if ( tusdeger == sagtus && tile1.r != 0 )tile1.r =tile1.r - 1 ;   
   if ( tusdeger==alttus && carpmasol()==0 ) tile1.r = tile1.r + 1 ;   
   if ( tusdeger==usttus && carpmasag()==0 ) tile1.r = tile1.r - 1 ;   
   
   tile1.pixr = tile1.r*5;  //----------------------
   tile1.pixc = tile1.c*5;  //----------------------
   //if ( tusdeger == alttus && carpmaalt()!=1  ) tile1.c =tile1.c + 1;
   printf("\f%u\n\r",  tile1.c);
   tileciz();
   
   for ( sayac = 0 ; sayac != score ; sayac++ ) glcd_pixel ( 123, sayac*2 + 5, 1 );
   
   glcd_update ();

   tile1.c++;
   if ( carpmaalt()) {  //tile1.c == 25 ||
     if ( tile1.c < 2 ) reset_cpu(); 
     for ( row = 0 ; row < 4 ; row++){
      for ( col = 0 ; col < 4 ; col++){
       
         if ( tiles[row][tile1.type*4+col] == 'x' ) {
            //printf( "x" );  
            maze [tile1.r+row][tile1.c+col-1] = 'x';
         }
         
     }

   }
   mazebasx();
      tile1.c=0 ;
      tile1.type = sonrakitile ;

      sonrakitile = (int) rand();
      tile1.r=4;
   }
   

   satirbak();

   
   
   
   
   }
}
